bsa<-function (x, y, x.level) {
  fn_perm_list <- function(n, r, v = 1:n) {
    if (r == 1)
      matrix(v, n, 1)
    else if (n == 1)
      matrix(v, 1, r)
    else {
      X <- NULL
      for (i in 1:n) X <- rbind(X, cbind(v[i], fn_perm_list(n -
                                                              1, r - 1, v[-i])))
      X
    }
  }
  fn_comb_list = function(idmatrix, count) {
    row.count = length(count)
    if (row.count == 1) {
      comb.list = matrix(idmatrix[1:count])
    }
    if (row.count > 1) {
      sub.comb.list = fn_comb_list(idmatrix[-1, ], count[-1])
      temp.comb = c()
      for (j in idmatrix[1, 1:count[1]]) {
        temp.comb = rbind(temp.comb, cbind(j, sub.comb.list))
      }
      comb.list = temp.comb
    }
    return(comb.list)
  }
  level.x = as.numeric(levels(factor(x)))
  if (length(level.x) < length(x.level)) {
    return(list(bsa = NA, sd = NA, flag = 0))
  }
  else {
    BSA = function(x, y) {
      level.x = as.numeric(levels(factor(x)))
      n.levels = length(level.x)
      r0 = 1:n.levels
      id = 1:length(x)
      denom.mat2 = fn_perm_list(n.levels, n.levels)
      denom.mat1 = matrix(rep(r0, rep(dim(denom.mat2)[1],
                                      n.levels)), dim(denom.mat2)[1], n.levels)
      denom = sum((denom.mat1 - denom.mat2)^2)/dim(denom.mat2)[1]
      subset.id = matrix(NA, nrow = n.levels, ncol = length(x))
      levels.count = rep(0, n.levels)
      for (i in 1:n.levels) {
        index.leveli = (x == level.x[i])
        levels.count[i] = sum(index.leveli)
        if (levels.count[i] > 0) {
          subset.id[i, 1:sum(index.leveli)] = id[index.leveli]
        }
      }
      if (prod(levels.count) == 0) {
        flag = 0
        bsa = NA
      }
      if (prod(levels.count) > 0) {
        flag = 1
        design.mat = fn_comb_list(subset.id, levels.count)
        y.mat = matrix(y[as.vector(design.mat)], nrow = dim(design.mat)[1])
        rank.mat = matrix(0, dim(y.mat)[1], 3)
        y.rank = t(apply(y.mat, 1, rank))
        r0.mat = matrix(rep(r0, rep(dim(design.mat)[1],
                                    length(r0))), nrow = dim(design.mat)[1])
        nom = sum((y.rank - r0.mat)^2)/prod(levels.count)
        bsa = 1 - nom/denom
      }
      return(c(bsa, flag))
    }
    jack.sd = function(x, y) {
      jack.est = c()
      for (jack in 1:length(x)) {
        x.jack = x[-jack]
        y.jack = y[-jack]
        temp.est = BSA(x.jack, y.jack)
        jack.est = rbind(jack.est, temp.est)
      }
      flag.jack = floor(mean(jack.est[, 2]))
      if (flag.jack == 1) {
        jack.mean = mean(jack.est[, 1])
        est.sd = sqrt((length(x) - 1)/(length(x)) * sum((jack.est[,
                                                                  1] - jack.mean)^2))
      }
      if (flag.jack == 0) {
        est.sd = NA
      }
      return(c(est.sd, flag.jack))
    }
    return(list(bsa = BSA(x, y)[1], sd = jack.sd(x, y)[1],
                flag = round(BSA(x, y)[2], 0)))
  }
}
