
bsa.fast<-function(data,status,x.level){
  require(survival)
  time=data[,c(2,1)]
  newfun_1<-function(S1,S2,w1,w2){
    wp1=-diff(S1)
    temp=0
    for(i in 1:(length(S1)-1)){
      temp=temp+tempfun_1(w1[i],w1[i+1],S2,w2)*wp1[i]
    }
    return(temp)
  }

  tempfun_1<-function(x1,x2,S,w){#### revised for lebesgue-Stieltjs integration
    if(x2>=w[length(w)]){return (0)
    }else{
      minw=which.min(w<=x2)-1
      return(S[minw])}

  }


  new_func_bsa_1<-function(time,status,x.level){
    bsa_temp=0
    mintime=min(time[,1])-1
    maxtime=max(time[,1])+1
    maxlevel=length(x.level)

    level.x = as.numeric(levels(factor(time[,2])))
    n.levels = length(level.x)
    levels.count = rep(0, n.levels)

    for (i in 1:n.levels) {
      index.leveli = (time[,2] == level.x[i])
      levels.count[i] = sum(index.leveli)
    }
    if (prod(levels.count) == 0){
      flag = 0
      bsa = NA
    }
    if(prod(levels.count)>=1){
      flag=1
      for (r in 1:(maxlevel-1)){
        gr=NULL
        wr=c(mintime,sort(unique(time[time[,2]==x.level[r] & status==1,1])))
        gr=summary(survival::survfit(Surv(time[time[,2]==x.level[r],1], status[time[,2]==x.level[r]])~1))
        Sr=c(1,gr$surv)
        if (Sr[length(Sr)]>0) {# add mass point to censoring distribution, if needed
          Sr=c(Sr,0)
          wr=c(wr,maxtime)
        }
        for(l in (r+1):maxlevel){
          gl=NULL
          wl=c(mintime,sort(unique(time[time[,2]==x.level[l] & status==1,1])))
          gl=summary(survival::survfit(Surv(time[time[,2]==x.level[l],1], status[time[,2]==x.level[l]])~1))
          Sl=c(1,gl$surv)
          if (Sl[length(Sl)]>0) {
            Sl=c(Sl,0)
            wl=c(wl,maxtime)
          }
          bsa_temp=bsa_temp+2*(l-r)*newfun_1(Sr,Sl,wr,wl)
        }
      }
      bsa=bsa_temp*6/(maxlevel^3-maxlevel)-1
    }
    return(c(bsa,flag))
  }
  jack.sd.new_1<-function(time,status,x.level){
    jack.est=c()
    for(jack in 1:length(status)){
      time.jack=time[-jack,]
      status.jack=status[-jack]
      temp.est=new_func_bsa_1(time.jack,status.jack,x.level)
      jack.est=rbind(jack.est,temp.est)
    }

    flag.jack = floor(mean(jack.est[, 2]))
    if (flag.jack == 1) {
      jack.mean = mean(jack.est[, 1])
      est.sd=sqrt((length(status)-1)/(length(status))*sum((jack.est[,1]-jack.mean)^2))
    }
    if (flag.jack == 0) {
      est.sd = NA
    }
    return(c(est.sd, flag.jack))
  }
  level.x = as.numeric(levels(factor(time[,2])))
  if (length(level.x) < length(x.level)) {
    return(list(bsa = NA, sd = NA, flag = 0))
  }else{
    return(list(bsa = new_func_bsa_1(time,status,x.level)[1], sd = jack.sd.new_1(time,status,x.level)[1],
                flag = round(new_func_bsa_1(time,status,x.level)[2], 0)))
  }


}
