lbsa<-function (x, y, x.level){
  fisherz = function(rho) {
    fisherz = 0.5 * log((1 + rho)/(1 - rho))
    return(fisherz)
  }
  dfisherz = function(rho) {
    dfisherz = 1/(1 - rho^2)
    return(dfisherz)
  }
  time_point <- dim(x)[2]
  index0 = 0
  est.vec = c()
  temp.est = c()
  if (time_point == 1) {
    return("ERROR, data should at least have two time points")
  }
  else {
    for (i in 1:time_point) {
      temp.est1 = bsa(x[, i], y[, i], x.level)$bsa
      temp.est = rbind(temp.est, temp.est1)
      index0 = (abs(temp.est1) == 1) + index0
      est.vec = c(est.vec, temp.est1)
    }
    Dn.ori = (est.vec[-1] - est.vec[1]) * sqrt(dim(x)[1])
    Dn.fisher = (fisherz(est.vec[-1]) - fisherz(est.vec[1])) *
      sqrt(dim(x)[1])
    var.jack.ori = lvar(x, y, x.level)
    if (index0 != 0) {
      if (mean(est.vec) <= 0) {
        est.vec = c()
        temp.est = c()
        x1 <- matrix(0, (dim(x)[1] + time_point - 1),
                     time_point)
        y1 <- matrix(0, (dim(x)[1] + time_point - 1),
                     time_point)
        for (j in 1:time_point) {
          pseudo1 = negative_pseudo.func(x[, j], y[,
                                                   j])
          x1[, j] <- pseudo1$a
          y1[, j] <- pseudo1$b
          temp.est1.p = bsa(pseudo1$a, pseudo1$b, x.level)$bsa
          temp.est = rbind(temp.est, temp.est1.p)
          est.vec = c(est.vec, temp.est1.p)
        }
        Dn.ori = (est.vec[-1] - est.vec[1]) * sqrt(dim(x)[1])
        Dn.fisher = (fisherz(est.vec[-1]) - fisherz(est.vec[1])) *
          sqrt(dim(x)[1])
        var.jack.ori = lvar(x1, y1, x.level)
      }
      else if (mean(est.vec) > 0) {
        est.vec = c()
        temp.est = c()
        x1 <- matrix(0, (dim(x)[1] + time_point - 1),
                     time_point)
        y1 <- matrix(0, (dim(x)[1] + time_point - 1),
                     time_point)
        for (j in 1:time_point) {
          pseudo1 = positive_pseudo.func(x[, j], y[,
                                                   j])
          x1[, j] <- pseudo1$a
          y1[, j] <- pseudo1$b
          temp.est1.p = bsa(pseudo1$a, pseudo1$b, x.level)$bsa
          temp.est = rbind(temp.est, temp.est1.p)
          est.vec = c(est.vec, temp.est1.p)
        }
        Dn.ori = (est.vec[-1] - est.vec[1]) * sqrt(dim(x)[1])
        Dn.fisher = (fisherz(est.vec[-1]) - fisherz(est.vec[1])) *
          sqrt(dim(x)[1])
        var.jack.ori = lvar(x1, y1, x.level)
      }
    }
    delta.vec = dfisherz(c((est.vec[1] + est.vec[-1])/2))
    delta.vec[delta.vec == Inf] = 100
    var.jack.fisher = matrix(0, time_point - 1, time_point -
                               1)
    for (i in 1:(time_point - 1)) {
      for (j in 1:(time_point - 1)) {
        var.jack.fisher[i, j] = var.jack.ori[i, j] *
          delta.vec[i] * delta.vec[j]
      }
    }
    test.stat = NA
    if (index0 == time_point) {
      test.stat = 0
    }
    if (index0 == 0) {
      if (qr(var.jack.fisher)$rank == (time_point - 1)) {
        test.stat = matrix(Dn.fisher, 1) %*% solve(var.jack.fisher) %*%
          matrix(Dn.fisher)
      }
    }
    return(list(est.bsa = est.vec, Dn.ori = Dn.ori, Dn.fisher = Dn.fisher,
                var.ori = var.jack.ori, var.jack.fisher = var.jack.fisher,
                T = test.stat, indx = index0))
  }
}
