\title{
Calculating broad sense agreement coefficient between ordinal and continuous variables
}\name{BSA-package}\alias{BSA-package}\alias{BSA}\keyword{ package }\description{
Calculating broad sense agreement coefficient for ordinal and continuous variables with one time point or longitudinal settings.
}\details{
\tabular{ll}{
Package: \tab BSA\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Depends: \tab R (>= 3.0.1)\cr
         \tab survival\cr

Date: \tab 2020-03-06\cr
License: \tab GPL-2\cr
}
Major functions include \emph{bsa}, \emph{bsa.fast}, \emph{lbsa} and \emph{lvar}. \emph{bsa} and \emph{bsa.fast} are used for one time point. \emph{bsa} is based on stratified sampling method. \emph{bsa.fast} is based on empricial survival function. \emph{lbsa} and \emph{lvar} are used for longitudinal data.
}\author{
Qingpo Cai and Bo Wei

Maintainer: Bo Wei <bwei8@emory.edu>
}\references{
Peng, L., Li, R., Guo, Y., and Manatunga, A.
A Framework for Assessing Broad Sense Agreement Between Ordinal and Continuous Measurements
Journal of the American Statistical Association, 106: 1592--1601, 2011.

Wei, B., Dai, T., Peng, L., Guo, Y. and Manatunga, A., 2020. A new functional representation of broad sense agreement. Statistics & Probability Letters, 158, p.108619.

}\examples{
N=40
x.level<-1:3
x=sample(1:3,N,replace=TRUE)
y=rnorm(N,sd=0.8)+x

bsa(x,y,x.level)
bsa.fast(cbind(x,y),rep(1,N),x.level)

x1<-sample(1:3,N,replace=TRUE)
y1<-rnorm(N,sd=1)+x1
x2<-cbind(x,x1)
y2<-cbind(y,y1)
lbsa(x2,y2,x.level)
lvar(x2,y2,x.level)
}
