\name{bsa}
\alias{bsa}
\title{
Calculating broad sense agreement coefficient the jackknife standard deviation for one time point based on stratified sampling method
}
\description{
This function is used for calculating broad sense agreement coefficient between an ordinal variable and a continuous variable with one time point, and its jackknife standard deviation based on stratified sampling method.
}
\usage{
bsa(x,y,x.level)
}
\arguments{
  \item{x}{
A vector of an ordinal variable.
}
  \item{y}{
A vector of a continuous variable.
}
\item{x.level}{
A numeric vector indicating the levels of ordinal variable x.
}
}

\value{
\emph{bsa} returns a list containing the following components:
\item{bsa}{the estimated broad sense agreement coefficient.}
\item{sd}{the jackknife standard deviation.}
\item{flag}{0 means no data for at least one level of x and bsa and sd are both NA. flag=1 means every level has data.}
}

\author{
Qingpo Cai
}
\references{
Peng, L., Li, R., Guo, Y., and Manatunga, A.
A Framework for Assessing Broad Sense Agreement Between Ordinal and Continuous Measurements
Journal of the American Statistical Association, 106: 1592--1601, 2011.
}\examples{
N=40
x=sample(1:3,N,replace=TRUE)
y=rnorm(N,sd=0.8)+x
x.level<-1:3
bsa(x,y,x.level)
}
