\title{
Jackknife variance estimator of BSA for longitudinal data
}\name{lvar}
\alias{lvar}
\description{
Using jackknife method to calculate the variance estimator of broad sense agreement coefficient for longitudinal settings.
}\usage{
lvar(x,y,x.level)
}\arguments{
  \item{x}{
A matrix or data.frame indicating the ordinal variable, with at least 2 columns.
}
  \item{y}{
A matrix or data.frame indicating the continuous variable, with at least 2 columns.
}
\item{x.level}{
A numeric vector indicating the levels of ordinal variable x.
}
}\value{
Return value is a matrix.
}\author{
Qingpo Cai
}\references{
Peng, L., Li, R., Guo, Y., and Manatunga, A.
A Framework for Assessing Broad Sense Agreement Between Ordinal and Continuous Measurements
Journal of the American Statistical Association, 106: 1592--1601, 2011.
}
\examples{
N=40
x=sample(1:3,N,replace=TRUE)
y=rnorm(N,sd=0.8)+x
x1<-sample(1:3,N,replace=TRUE)
y1<-rnorm(N,sd=1)+x1
x2<-cbind(x,x1)
y2<-cbind(y,y1)
x.level<-1:3
lvar(x2,y2,x.level)
}
