\title{
Inserting pseudo data when BSA is -1
}\name{negative_pseudo.func}\alias{negative_pseudo.func}\description{
Inserting pseudo data at all time points to recalculate BSA and the test statistic if the estimated BSA at any time point equals -1.
}
\usage{
negative_pseudo.func(x, y)
}
\arguments{
  \item{x}{
A numeric vector indicating the ordinal variable
}
  \item{y}{
A numeric vector indicating the continuous variable
}
}
\value{
\emph{negative_pseudo.func} returns a list containing the following components:
\item{a}{An ordinal data after inserting pseudo data}
\item{b}{A continuous data after inserting pseudo data}
}
\author{
Qingpo Cai
}\references{
Peng, L., Li, R., Guo, Y., and Manatunga, A.
A Framework for Assessing Broad Sense Agreement Between Ordinal and Continuous Measurements
Journal of the American Statistical Association, 106: 1592--1601, 2011.
}\examples{
N=40
x=sample(1:3,N,replace=TRUE)
y=rnorm(N,sd=0.8)+x
negative_pseudo.func(x,y)
}
